# Experiment 8 - Impact of Snapshot

## Settings

- Object size
  + 16B key + 128B value
- Workloads
  + Synthetic: 100% write + 0.99 skewness
- Method
  + FarReach
- Static pattern
	+ Simulate 16 servers by server rotation with 0s/1s/5s/10s snapshot interval
	+ hotin/hotout/random rule maps

## Round 1 - Throughput (MOPS)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| Static | 1.814 | 1.914 | 2.014 | 1.934 | 1.959 |
| hotin  | 0.202 | 0.214 | 0.216 | 0.207 | 0.212 |
| hotout | 0.222 | 0.211 | 0.213 | 0.216 | 0.212 |
| random | 0.220 | 0.205 | 0.208 | 0.212 | 0.218 |
</br>

## Round 1 - Bandwidth Cost (MiB/s)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| Static | - | 1.767 | 0.818 | 0.617 | 0.426 |
| hotin  | 0.028 | 1.364 | 0.665 | 0.410 | 0.247 |
| hotout | 0.023 | 1.382 | 0.650 | 0.465 | 0.367 |
| random | 0.023 | 1.365 | 0.683 | 0.458 | 0.331 |
</br>

## Round 2 - Throughput (MOPS)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| hotin  | 0.177 | 0.216 | 0.208 | 0.213 | 0.162 |
| hotout | 0.201 | 0.210 | 0.210 | 0.210 | 0.219 |
| random | 0.195 | 0.210 | 0.225 | 0.185 | 0.221 |
</br>

## Round 2 - Bandwidth Cost (MiB/s)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| hotin  | 0.028 | 1.469 | 0.660 | 0.411 | 0.279 |
| hotout | 0.023 | 1.313 | 0.699 | 0.496 | 0.325 |
| random | 0.023 | 1.400 | 0.659 | 0.452 | 0.316 |
</br>

## Round 3 - Throughput (MOPS)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| hotin  | 0.158 | 0.209 | 0.230 | 0.207 | 0.178 |
| hotout | 0.215 | 0.224 | 0.211 | 0.214 | 0.209 |
| random | 0.202 | 0.211 | 0.217 | 0.217 | 0.197 |
</br>

## Round 3 - Bandwidth Cost (MiB/s)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| hotin  | 0.028 | 1.334 | 0.730 | 0.375 | 0.317 |
| hotout | 0.022 | 1.487 | 0.687 | 0.414 | 0.331 |
| random | 0.023 | 1.373 | 0.700 | 0.428 | 0.319 |
</br>

## Round 4 - Throughput (MOPS)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| hotin  | 0.218 | 0.199 | 0.192 | 0.205 | 0.203 |
| hotout | 0.227 | 0.221 | 0.211 | 0.199 | 0.217 |
| random | 0.209 | 0.198 | 0.200 | 0.198 | 0.220 |
</br>

## Round 4 - Bandwidth Cost (MiB/s)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| hotin  | 0.029 | 1.335 | 0.641 | 0.461 | 0.336 |
| hotout | 0.024 | 1.413 | 0.754 | 0.410 | 0.336 |
| random | 0.023 | 1.337 | 0.605 | 0.421 | 0.317 |
</br>

## Round 5 - Throughput (MOPS)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| hotin  | 0.222 | 0.206 | 0.212 | 0.202 | 0.215 |
| hotout | 0.232 | 0.215 | 0.212 | 0.215 | 0.220 |
| random | 0.230 | 0.210 | 0.219 | 0.216 | 0.215 |
</br>

## Round 5 - Bandwidth Cost (MiB/s)
|   | 0 | 2.5 | 5 | 7.5 | 10 |
|:-:|:------:|:-------:|:------:|:-------:|:-------:|
| hotin  | 0.029 | 1.331 | 0.680 | 0.394 | 0.314 |
| hotout | 0.024 | 1.442 | 0.704 | 0.375 | 0.286 |
| random | 0.023 | 1.433 | 0.670 | 0.436 | 0.294 |
</br>