# Experiment 6 - Impact of Value Size

## Settings

- Object size
  + 16B key + 16/32/64/128B value
- Workloads
  + Synthetic: 100% write + 0.99 skewness
- Method
  + FarReach
  + NoCache
  + NetCache
- Evaluation pattern
	+ Simulate 16 servers by server rotation


## Round 1 - Throughput (MOPS)
|  Method  | 16 | 32 | 64 | 128 | 256 |
|:--------:|:----------:|:----------:|:----------:|:----------:|:----------:|
| FarReach | 2.074 | 2.005 | 2.005 | 1.997 | 0.762 |
| NoCache  | 0.818 | 0.817 | 0.841 | 0.855 | 0.709 |
| NetCache | 0.690 | 0.686 | 0.697 | 0.685 | 0.709 |
</br>

## Round 1 - Normalized throughput
|  Method  | 16 | 32 | 64 | 128 | 256 |
|:--------:|:----------:|:----------:|:----------:|:----------:|:----------:|
| FarReach |  26.149  |  26.101  |  26.077  |  26.076  |  11.000  |
| NoCache  |  11.049  |  11.001  |  11.029  |  11.041  |  10.999  |
| NetCache |  11.031  |  11.029  |  11.055  |  11.068  |  11.024  |
</br>

## Round 2 - Throughput (MOPS)
|  Method  | 16 | 32 | 64 | 128 |
|:--------:|:----------:|:----------:|:----------:|:----------:|
| FarReach | 1.974 | 1.885 | 1.845 | 1.795 |
| NoCache  | 0.836 | 0.828 | 0.836 | 0.781 |
| NetCache | 0.716 | 0.696 | 0.692 | 0.646 |
</br>

## Round 2 - Normalized throughput
|  Method  | 16 | 32 | 64 | 128 |
|:--------:|:----------:|:----------:|:----------:|:----------:|
| FarReach |  26.073  |  26.053  |  26.032  |  25.994  |
| NoCache  |  11.056  |  11.025  |  11.029  |  11.055  |
| NetCache |  11.068  |  11.009  |  11.050  |  11.024  |
</br>

## Round 3 - Throughput (MOPS)
|  Method  | 16 | 32 | 64 | 128 |
|:--------:|:----------:|:----------:|:----------:|:----------:|
| FarReach | 2.030 | 1.948 | 1.890 | 1.959 |
| NoCache  | 0.877 | 0.856 | 0.806 | 0.848 |
| NetCache | 0.705 | 0.697 | 0.702 | 0.681 |
</br>

## Round 3 - Normalized throughput
|  Method  | 16 | 32 | 64 | 128 |
|:--------:|:----------:|:----------:|:----------:|:----------:|
| FarReach |  26.084  |  26.409  |  26.410  |  26.069  |
| NoCache  |  11.030  |  11.047  |  11.051  |  11.009  |
| NetCache |  11.032  |  11.033  |  11.050  |  11.011  |
</br>


## Round 4 - Throughput (MOPS)
|  Method  | 16 | 32 | 64 | 128 |
|:--------:|:----------:|:----------:|:----------:|:----------:|
| FarReach | 1.902 | 1.853 | 1.801 | 1.835 |
| NoCache  | 0.798 | 0.761 | 0.756 | 0.713 |
| NetCache | 0.678 | 0.636 | 0.667 | 0.631 |
</br>

## Round 4 - Normalized throughput
|  Method  | 16 | 32 | 64 | 128 |
|:--------:|:----------:|:----------:|:----------:|:----------:|
| FarReach |  26.050  |  26.020  |  25.947  |  26.059  |
| NoCache  |  11.024  |  11.032  |  11.030  |  11.026  |
| NetCache |  11.052  |  11.031  |  11.020  |  11.051  |
</br>

## Round 5 - Throughput (MOPS)
|  Method  | 16 | 32 | 64 | 128 |
|:--------:|:----------:|:----------:|:----------:|:----------:|
| FarReach | 1.907 | 1.811 | 1.827 | 1.850 |
| NoCache  | 0.781 | 0.754 | 0.781 | 0.766 |
| NetCache | 0.678 | 0.661 | 0.635 | 0.620 |
</br>

## Round 5 - Normalized throughput
|  Method  | 16 | 32 | 64 | 128 |
|:--------:|:----------:|:----------:|:----------:|:----------:|
| FarReach |  26.042  |  26.027  |  26.023  |  26.047  |
| NoCache  |  11.031  |  11.046  |  11.022  |  11.050  |
| NetCache |  11.053  |  11.028  |  11.014  |  10.963  |
</br>