# Experiment 4 - Impact of Write Ratio

## Settings

- Object size
  + 16B key + 128B value
- Workloads
  + Synthetic-0: 100% read + 0% write + 0.99 skewness
  + Synthetic-25: 75% read + 25% write + 0.99 skewness
  + Synthetic-50: 50% read + 50% write + 0.99 skewness
  + Synthetic-75: 25% read + 75% write + 0.99 skewness
  + Synthetic-100: 0% read + 100% write + 0.99 skewness
- Method
  + FarReach
  + NoCache
  + NetCache
- Evaluation pattern
	+ Simulate 16 servers by server rotation


## Round 1 - Throughput (MOPS)
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach | 1.478 | 1.364 | 1.594 | 1.595 | 1.997 |
| NoCache  | 0.732 | 0.772 | 0.765 | 0.808 | 0.855 |
| NetCache | 1.580 | 0.888 | 0.819 | 0.716 | 0.685 |
</br>

## Round 1 - Normalized throughput
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach |  25.986  |  26.021  |  26.076  |  26.021  |  26.076  |
| NoCache  |  11.037  |  11.026  |  11.028  |  11.026  |  11.041  |
| NetCache |  26.391  |  15.516  |  13.658  |  12.247  |  11.068  |
</br>

## Round 2 - Throughput (MOPS)
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach | 1.424 | 1.265 | 1.454 | 1.506 | 1.795 |
| NoCache  | 0.753 | 0.757 | 0.743 | 0.724 | 0.781 |
| NetCache | 1.351 | 0.824 | 0.766 | 0.690 | 0.646 |
</br>

## Round 2 - Normalized throughput
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach |  25.953  |  25.946  |  26.353  |  25.985  |  25.994  |
| NoCache  |  11.018  |  11.061  |  11.019  |  11.033  |  11.055  |
| NetCache |  26.025  |  14.917  |  13.634  |  12.206  |  11.024  |
</br>

## Round 3 - Throughput (MOPS)
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach | 1.421 | 1.204 | 1.411 | 1.578 | 1.847 |
| NoCache  | 0.753 | 0.794 | 0.759 | 0.784 | 0.848 |
| NetCache | 1.476 | 0.866 | 0.767 | 0.717 | 0.681 |
</br>

## Round 3 - Normalized throughput
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach |  25.990  |  25.829  |  25.962  |  26.020  |  26.094  |
| NoCache  |  11.018  |  11.032  |  11.037  |  11.008  |  11.009  |
| NetCache |  25.969  |  15.606  |  13.579  |  12.198  |  11.011  |
</br>

## Round 4 - Throughput (MOPS)
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach | 1.468 | 1.206 | 1.298 | 1.422 | 1.835 |
| NoCache  | 0.804 | 0.699 | 0.690 | 0.693 | 0.713 |
| NetCache | 1.446 | 0.802 | 0.677 | 0.661 | 0.631 |
</br>

## Round 4 - Normalized throughput
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach |  25.978  |  25.915  |  25.944  |  25.929  |  26.059  |
| NoCache  |  11.050  |  11.044  |  11.055  |  10.982  |  11.026  |
| NetCache |  25.971  |  15.481  |  13.661  |  12.179  |  11.051  |
</br>

## Round 5 - Throughput (MOPS)
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach | 1.413 | 1.176 | 1.330 | 1.463 | 1.850 |
| NoCache  | 0.803 | 0.697 | 0.740 | 0.723 | 0.766 |
| NetCache | 1.486 | 0.811 | 0.783 | 0.663 | 0.620 |
</br>

## Round 5 - Normalized throughput
|  Method  | 0 | 25 | 50 | 75 | 100 |
|:--------:|:----------:|:----------:|:----------:|:-----------:|:----------:|
| FarReach |  25.994  |  25.797  |  25.809  |  25.936  |  26.047  |
| NoCache  |  11.050  |  11.037  |  11.027  |  11.055  |  11.050  |
| NetCache |  25.930  |  15.523  |  13.480  |  12.208  |  10.963  |
</br>